# Generated by ariadne-codegen
# Source: queries.graphql

from datetime import datetime
from decimal import Decimal
from typing import List, Optional

from pydantic import Field

from architect_py.scalars import OrderDir

from .base_model import BaseModel
from .enums import AlgoRunningStatus


class GetTwapStatus(BaseModel):
    twap_status: List["GetTwapStatusTwapStatus"] = Field(alias="twapStatus")


class GetTwapStatusTwapStatus(BaseModel):
    order_id: str = Field(alias="orderId")
    order: Optional["GetTwapStatusTwapStatusOrder"]
    creation_time: datetime = Field(alias="creationTime")
    status: AlgoRunningStatus
    fraction_complete: Optional[float] = Field(alias="fractionComplete")
    realized_twap: Optional[Decimal] = Field(alias="realizedTwap")
    quantity_filled: Decimal = Field(alias="quantityFilled")


class GetTwapStatusTwapStatusOrder(BaseModel):
    name: str
    order_id: str = Field(alias="orderId")
    market_id: str = Field(alias="marketId")
    dir: OrderDir
    quantity: Decimal
    end_time: datetime = Field(alias="endTime")
    account_id: Optional[str] = Field(alias="accountId")
    interval_ms: int = Field(alias="intervalMs")
    reject_lockout_ms: int = Field(alias="rejectLockoutMs")
    take_through_frac: Optional[Decimal] = Field(alias="takeThroughFrac")


GetTwapStatus.model_rebuild()
GetTwapStatusTwapStatus.model_rebuild()
